$(function() {
    $('.dP').datepicker({
      showWeek: true,
      firstDay: 1,
      changeMonth: true,
      changeYear: true,
      dateFormat: 'yy-mm-dd',
      defaultDate: 0
    });
    
    $('#diffDiv').html('Please enter or pick two dates in the fields above.');

    $('.dP').change(dateDiffChange);

    window.onpopstate = function(e) {
	updateDatesFromUrl();
	updateDateDiff();
    }

    updateDatesFromUrl();
    updateDateDiff();
  });

function updateDatesFromUrl() {
  // Pull the URL parameters and look for 'startDate' and 'endDate'.
  var params = $.getUrlVars();
  
  if (params['startDate'] != null)
    $('#startDate').datepicker('setDate', new Date(Date.parse(params['startDate'])));
    //$('#startDate').val(params['startDate']);
  
  if (params['endDate'] != null)
    $('#endDate').datepicker('setDate', new Date(Date.parse(params['endDate'])));
    //$('#endDate').val(params['endDate']);
}

function dateDiffChange() {
  window.history.pushState('', '', '?startDate=' + $('#startDate').val() + '&endDate=' + $('#endDate').val());

  updateDateDiff();
}

function updateDateDiff() {  
  var startDate = new Date(Date.parse($('#startDate').val()));
  var endDate   = new Date(Date.parse($('#endDate'  ).val()));
  
  if (!isValidDate(startDate) ||
      !isValidDate(endDate))
    {
      $('#diffDiv').html('Please enter or pick two dates in the fields above.');
      return;
    }

  var diff = Math.round(Math.abs(endDate.getTime() - startDate.getTime()) / (1000*60*60*24));
  
  $('#diffDiv').show('highlight', '', 1000);
  $('#diffDiv').html('There are <span id="daysDiff" class="dateDifference">' + diff + '</span> day(s) between the above dates.');
}

function isValidDate(d) {
  if ( Object.prototype.toString.call(d) !== "[object Date]" )
    return false;
  return !isNaN(d.getTime());
}

// Thanks to UZBEKJON over at
// http://jquery-howto.blogspot.com/2009/09/get-url-parameters-values-with-jquery.html
// for this piece of code.
$.extend({
  getUrlVars: function(){
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
      hash = hashes[i].split('=');
      vars.push(hash[0]);
      vars[hash[0]] = hash[1];
    }
    return vars;
  },
  getUrlVar: function(name){
    return $.getUrlVars()[name];
  }
});

/***** GOOGLE ANALYTICS *****/
var _gaq = _gaq || [];
_gaq.push(['_setAccount', 'UA-22306452-2']);
_gaq.push(['_trackPageview']);

(function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
 })();
/***** GOOGLE ANALYTICS *****/
